#include <iostream>
#include <cmath>

using namespace std;
int a[100000];
int b[100000];

int main()
{
    long long n, m, c;
    cin >> n >> m;
    for(int i = 1 ; i <= m ; i++)
    {
        cin >> b[i];
    }
    cin >> c;
    for (int i = 1 ;i <= n ; i++)
    {
        a[i] = i;
    }

    for (int i = 0; i<= n-m ; i++)
    {
        for (int j = 1 ; j<= m ;j++)
        {
            a[i + b[j]] = a[i + j];
        }
    }

    long long x = 0;
    for(int i = 1 ; i<= n ; i++)
    {
            x = x + (pow(c, i) * a[i]);
    }
    long long p = 998244353;
    cout << x % p << endl;

    return 0;
}